package com.engine.kqsolution.service;

import com.engine.kqsolution.entity.HistoryResourcePO;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.List;
import java.util.Map;

/**
 * @Author liang.cheng
 * @Date 2024/8/29 9:26 AM
 * @Description: TODO
 * @Version 1.0
 */
public interface ResourceSnipService {

    /**
     * @Description: 花名册快照
     * @Author: liang.cheng
     * @Date: 2024/8/29 9:58 AM
     * @param: [monthDate, companyStartDate]
     * @return: java.util.Map<java.lang.String,java.lang.Object>
     */
    Map<String,Object> resourceSnip(String monthDate, String companyStartDate);

    /**
     * 花名册快照导出
     * @param request
     * @param response
     * @param monthDate
     * @param companyStartDate
     * @return
     */
    XSSFWorkbook snipshotExport(HttpServletRequest request, HttpServletResponse response, String monthDate, String companyStartDate);

    /**
     * @Description: 人事花名册
     * @Author: liang.cheng
     * @Date: 2024/9/10 5:35 PM
     * @param: [companyStartDate]
     * @return: java.util.Map<java.lang.String,java.lang.Object>
     */
    Map<String, List<HistoryResourcePO>> hrResource(Map<String, Object> param);

    /**
     * @Description 人事花名册导出
     * @Author: liang.cheng
     * @Date: 2024/9/11 3:18 PM
     * @param: [request, response, companyStartDate]
     * @return: org.apache.poi.xssf.usermodel.XSSFWorkbook
     */
    XSSFWorkbook hrResourceExport(HttpServletRequest request, HttpServletResponse response, Map<String, Object> param);
}
