package com.engine.kqsolution.service.impl;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.cloudstore.dev.api.service.Service_DevTable;
import com.cloudstore.eccom.constant.WeaBoolAttr;
import com.cloudstore.eccom.pc.table.WeaTable;
import com.cloudstore.eccom.pc.table.WeaTableColumn;
import com.cloudstore.eccom.pc.table.WeaTableType;
import com.engine.core.impl.Service;
import com.engine.kqsolution.entity.HistoryResourcePO;
import com.engine.kqsolution.entity.HrmStatusPO;
import com.engine.kqsolution.service.ResourceSnipService;
import com.engine.kqsolution.util.ExcelUtil;
import com.engine.kqsolution.util.ResourceSnipUtils;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;
import weaver.conn.RecordSet;
import weaver.general.BaseBean;
import weaver.general.PageIdConst;
import com.cloudstore.eccom.result.WeaResultMsg;
import weaver.general.StringUtil;
import weaver.general.Util;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.time.LocalDate;
import java.time.format.DateTimeFormatter;
import java.time.temporal.TemporalAdjusters;
import java.util.*;
import java.util.stream.Collectors;

/**
 * @Author liang.cheng
 * @Date 2024/8/29 9:27 AM
 * @Description: TODO
 * @Version 1.0
 */
public class ResourceSnipServiceImpl extends Service implements ResourceSnipService  {

    private static final DateTimeFormatter DATE_FORMATTER = DateTimeFormatter.ofPattern("yyyy-MM-dd");


    @Override
    public Map<String, Object> resourceSnip(String monthDate, String companyStartDate) {
        Map<String, Object> resultMap = new HashMap<>(4);

       //当前花名册
        if("".equals(monthDate)){
            BaseBean bb = new BaseBean();
            String account = bb.getPropValue("jcsecond", "account");
            String bankField = bb.getPropValue("jcsecond", "bankField");
            String regresidentplace = bb.getPropValue("jcsecond", "regresidentplace");
            String femdate = bb.getPropValue("jcsecond", "femdate");
            WeaTable table = new WeaTable();
            String pageId = "73ed858b37304757987724e81d096ff2";
            table.setPageID(pageId);
            table.setPageUID(String.format("%s_%s",pageId,user.getUID()));
            String pageSize = PageIdConst.getPageSize(pageId, user.getUID());
            table.setPagesize(pageSize);
            String fields = "a.id,a.workcode,a.lastname,a.birthday,a.sex,a.subcompanyid1,a.departmentid,a.managerid,a.companystartdate," +
                    " a.createdate,a.accumfundaccount,b."+account+" as account,b."+bankField+" as bankname,c."+femdate+" as femdate," +
                    " a.startdate,a.enddate,a.jobtitle,a.status,a.educationlevel,a.mobile,a.certificatenum," +
                    " a.nativeplace,b."+regresidentplace+" as regresidentplace";
            table.setBackfields(fields);
            String fromSql = " from hrmresource a\n" +
                    " left join cus_fielddata b on a.id = b.id and b.scopeid = 1\n" +
                    " left join cus_fielddata c on a.id = c.id and c.scopeid = -1\n";
            table.setSqlform(fromSql);
            if (!"".equals(companyStartDate)){
                String sqlWhere = " where 1=1 and a.status < 4 ";
                table.setSqlwhere(sqlWhere);
            }

            table.setSqlprimarykey("a.id");
            table.getColumns().add(new WeaTableColumn("id").setDisplay(WeaBoolAttr.FALSE));
            table.getColumns().add(new WeaTableColumn("10%", "编号", "workcode"));
            table.getColumns().add(new WeaTableColumn("10%", "姓名", "lastname"));
            table.getColumns().add(new WeaTableColumn("10%", "出生日期", "birthday"));
            table.getColumns().add(new WeaTableColumn("10%", "性别", "sex").setTransmethod("com.engine.kqsolution.util.ResourceSnipUtils.selectSexName"));
            table.getColumns().add(new WeaTableColumn("10%", "分部", "subcompanyid1").setTransmethod("com.engine.kqsolution.util.ResourceSnipUtils.selectSubCompanyName"));
            table.getColumns().add(new WeaTableColumn("10%", "部门", "departmentid").setTransmethod("com.engine.kqsolution.util.ResourceSnipUtils.selectDeptName"));
            table.getColumns().add(new WeaTableColumn("10%", "直接上级", "managerid").setTransmethod("com.engine.kqsolution.util.ResourceSnipUtils.selectResourceName"));
            table.getColumns().add(new WeaTableColumn("10%", "入职日期", "companystartdate"));
            table.getColumns().add(new WeaTableColumn("10%", "创建日期", "createdate"));
            table.getColumns().add(new WeaTableColumn("10%", "公积金账户", "accumfundaccount"));
            table.getColumns().add(new WeaTableColumn("10%", "工资账户", "account").setDisplay(WeaBoolAttr.FALSE));
            table.getColumns().add(new WeaTableColumn("10%", "工资银行", "bankname").setDisplay(WeaBoolAttr.FALSE).setTransmethod("com.engine.kqsolution.util.ResourceSnipUtils.selectBankName").setOtherpara(bankField));
            table.getColumns().add(new WeaTableColumn("10%", "首次参保时间", "femdate").setDisplay(WeaBoolAttr.FALSE));
            table.getColumns().add(new WeaTableColumn("10%", "合同开始日期", "startdate").setDisplay(WeaBoolAttr.FALSE));
            table.getColumns().add(new WeaTableColumn("10%", "合同结束日期", "enddate").setDisplay(WeaBoolAttr.FALSE));
            table.getColumns().add(new WeaTableColumn("10%", "岗位", "jobtitle").setDisplay(WeaBoolAttr.FALSE).setTransmethod("com.engine.kqsolution.util.ResourceSnipUtils.selectJobName"));
            table.getColumns().add(new WeaTableColumn("10%", "状态", "status").setDisplay(WeaBoolAttr.FALSE).setTransmethod("com.engine.kqsolution.util.ResourceSnipUtils.selectStatusName"));
            table.getColumns().add(new WeaTableColumn("10%", "学历", "educationlevel").setDisplay(WeaBoolAttr.FALSE).setTransmethod("com.engine.kqsolution.util.ResourceSnipUtils.selectEducName"));
            table.getColumns().add(new WeaTableColumn("10%", "电话", "mobile").setDisplay(WeaBoolAttr.FALSE));
            table.getColumns().add(new WeaTableColumn("10%", "身份证号", "certificatenum").setDisplay(WeaBoolAttr.FALSE));
            table.getColumns().add(new WeaTableColumn("10%", "籍贯", "nativeplace").setDisplay(WeaBoolAttr.FALSE));
            table.getColumns().add(new WeaTableColumn("10%", "户口所在地", "regresidentplace").setDisplay(WeaBoolAttr.FALSE));

            table.setTableType(WeaTableType.NONE);
            WeaResultMsg result = new WeaResultMsg(false);
            result.putAll(table.makeDataResult());
            result.success();
            resultMap.putAll(result.getResultMap());
            return resultMap;

        }else {
            //历史花名册
            WeaTable table = new WeaTable();
            String pageId = "89093fe16a7c4a38b26d4a47de791859";
            table.setPageID(pageId);
            table.setPageUID(String.format("%s_%s",pageId,user.getUID()));
            String pageSize = PageIdConst.getPageSize(pageId, user.getUID());
            table.setPagesize(pageSize);
            String fields = "t.id,t.gh,t.xm,t.csrq,t.xb,t.fb,t.bm,t.zjsj,t.rzrq,t.cjrq,t.gjjzh,t.gzzh,t.gzyx,t.sccbsj," +
                    " t.htksrq,t.htjsrq,t.gw,t.zt,t.xl,t.dh,t.sfzh,t.jg,t.hkszd,t.cdrq,t.lzrq";
            table.setBackfields(fields);
            String fromSql = " from uf_hmckz t";
            table.setSqlform(fromSql);
            String sqlWhere = " where 1=1 and t.cdrq = '"+monthDate+"' and t.zt < 4";
            table.setSqlwhere(sqlWhere);
            table.setSqlprimarykey("id");
            table.getColumns().add(new WeaTableColumn("id").setDisplay(WeaBoolAttr.FALSE));
            table.getColumns().add(new WeaTableColumn("10%", "编号", "gh"));
            table.getColumns().add(new WeaTableColumn("10%", "姓名", "xm"));
            table.getColumns().add(new WeaTableColumn("10%", "出生日期", "csrq"));
            table.getColumns().add(new WeaTableColumn("10%", "性别", "xb"));
            table.getColumns().add(new WeaTableColumn("10%", "分部", "fb"));
            table.getColumns().add(new WeaTableColumn("10%", "部门", "bm"));
            table.getColumns().add(new WeaTableColumn("10%", "直接上级", "zjsj"));
            table.getColumns().add(new WeaTableColumn("10%", "入职日期", "rzrq"));
            table.getColumns().add(new WeaTableColumn("10%", "创建日期", "cjrq"));
            table.getColumns().add(new WeaTableColumn("10%", "公积金账户", "gjjzh"));
            table.getColumns().add(new WeaTableColumn("10%", "工资账户", "gzzh").setDisplay(WeaBoolAttr.FALSE));
            table.getColumns().add(new WeaTableColumn("10%", "工资银行", "gzyx").setDisplay(WeaBoolAttr.FALSE));
            table.getColumns().add(new WeaTableColumn("10%", "首次参保时间", "sccbsj").setDisplay(WeaBoolAttr.FALSE));
            table.getColumns().add(new WeaTableColumn("10%", "合同开始日期", "htksrq").setDisplay(WeaBoolAttr.FALSE));
            table.getColumns().add(new WeaTableColumn("10%", "合同结束日期", "htjsrq").setDisplay(WeaBoolAttr.FALSE));
            table.getColumns().add(new WeaTableColumn("10%", "岗位", "gw").setDisplay(WeaBoolAttr.FALSE));
            table.getColumns().add(new WeaTableColumn("10%", "状态", "zt").setDisplay(WeaBoolAttr.FALSE).setTransmethod("com.engine.kqsolution.util.ResourceSnipUtils.selectStatusName"));
            table.getColumns().add(new WeaTableColumn("10%", "学历", "xl").setDisplay(WeaBoolAttr.FALSE));
            table.getColumns().add(new WeaTableColumn("10%", "电话", "dh").setDisplay(WeaBoolAttr.FALSE));
            table.getColumns().add(new WeaTableColumn("10%", "身份证号", "sfzh").setDisplay(WeaBoolAttr.FALSE));
            table.getColumns().add(new WeaTableColumn("10%", "籍贯", "jg").setDisplay(WeaBoolAttr.FALSE));
            table.getColumns().add(new WeaTableColumn("10%", "户口所在地", "hkszd").setDisplay(WeaBoolAttr.FALSE));
            table.getColumns().add(new WeaTableColumn("10%", "离职日期", "lzrq").setDisplay(WeaBoolAttr.FALSE));

            table.setTableType(WeaTableType.NONE);
            WeaResultMsg result = new WeaResultMsg(false);
            result.putAll(table.makeDataResult());
            result.success();
            resultMap.putAll(result.getResultMap());
            return resultMap;
        }
    }

    @Override
    public XSSFWorkbook snipshotExport(HttpServletRequest request, HttpServletResponse response, String monthDate, String companyStartDate) {

        BaseBean bb = new BaseBean();
        String bankField = bb.getPropValue("jcsecond", "bankField");

        //全字段导出
        List<Object> headerList = Arrays.asList("编号","姓名","出生日期","性别","分部","部门","直接上级","入职日期","创建日期","公积金账户","工资账户","工资银行","首次参保时间",
                "合同开始日期","合同结束日期","岗位","状态","学历","电话","身份证号","籍贯","户口所在地","离职日期");


        Map<String, Object> map = resourceSnip(monthDate, companyStartDate);
        String dataKey = Util.null2String(map.get("datas"));

        String getcounts = new Service_DevTable().getcounts(request, response, dataKey);
        JSONObject jsonObject = JSON.parseObject(getcounts);
        String count = jsonObject.getString("count");

        String datas = new Service_DevTable().datas(request, response, dataKey, count, "[]", "", "", "1", "");
        jsonObject = JSON.parseObject(datas);
        List<Map<String, String>> snipshotList = (List<Map<String, String>>) jsonObject.get("datas");

        List<List<Object>> rows = new LinkedList<>();
        boolean table = "".equals(monthDate);
        for (Map<String, String> snip : snipshotList) {
            List<Object> row = new LinkedList<>();
            row.add(table ? snip.get("workcodespan") : snip.get("gh"));
            row.add(table ? snip.get("lastnamespan") : snip.get("xm"));
            row.add(table ? snip.get("birthdayspan") : snip.get("csrq"));
            row.add(table ? snip.get("sexspan") : snip.get("xb"));
            row.add(table ? ResourceSnipUtils.selectSubCompanyName(snip.get("subcompanyid1")) : snip.get("fb"));
            row.add(table ? ResourceSnipUtils.selectDeptName(snip.get("departmentid")) : snip.get("bm"));
            row.add(table ? ResourceSnipUtils.selectResourceName(snip.get("managerid")) : snip.get("zjsj"));
            row.add(table ? snip.get("companystartdatespan") : snip.get("rzrq"));
            row.add(table ? snip.get("createdatespan") : snip.get("cjrq"));
            row.add(table ? snip.get("accumfundaccountspan") : snip.get("gjjzh"));
            row.add(table ? snip.get("accountspan") : snip.get("gzzh"));
            row.add(table ? ResourceSnipUtils.selectBankName(snip.get("subcompanyid1"),bankField) : snip.get("gzyx"));
            row.add(table ? snip.get("femdatespan") : snip.get("sccbsj"));
            row.add(table ? snip.get("startdatespan") : snip.get("htksrq"));
            row.add(table ? snip.get("enddatespan") : snip.get("htjsrq"));
            row.add(table ? ResourceSnipUtils.selectJobName(snip.get("jobtitle")) : snip.get("gw"));
            row.add(table ? ResourceSnipUtils.selectStatusName(snip.get("status")) : snip.get("zt"));
            row.add(table ? ResourceSnipUtils.selectEducName(snip.get("educationlevel")) : snip.get("xl"));
            row.add(table ? snip.get("mobilespan") : snip.get("dh"));
            row.add(table ? snip.get("certificatenumspan") : snip.get("sfzh"));
            row.add(table ? snip.get("nativeplacespan") : snip.get("jg"));
            row.add(table ? snip.get("regresidentplacespan") : snip.get("hkszd"));
            row.add(table ? snip.get("changedate") : snip.get("lzrq"));

            rows.add(row);
        }

        List<List<Object>> excelSheetData = new ArrayList<>();
        excelSheetData.add(headerList);
        excelSheetData.addAll(rows);
        String sheetName = "花名册快照"+monthDate;

        return ExcelUtil.genWorkbookV2(excelSheetData, sheetName);
    }

    @Override
    public Map<String, List<HistoryResourcePO>> hrResource(Map<String, Object> param) {

        String companyStartDate = Util.null2String(param.get("companyStartDate"));
        String status = Util.null2String(param.get("status"));
        String subcompanyId = Util.null2String(param.get("subcompanyId"));
        String departmentId = Util.null2String(param.get("departmentId"));

        Map<String, List<HistoryResourcePO>> resultMap = new HashMap<>(4);
        RecordSet rs = new RecordSet();
        BaseBean bb = new BaseBean();
        String account = bb.getPropValue("jcsecond", "account");
        String bankField = bb.getPropValue("jcsecond", "bankField");
        String regresidentplace = bb.getPropValue("jcsecond", "regresidentplace");
        String femdate = bb.getPropValue("jcsecond", "femdate");

        LocalDate firstDayOfMonth = LocalDate.parse(companyStartDate + "-01", DateTimeFormatter.ofPattern("yyyy-MM-dd"));
        LocalDate firstDay = firstDayOfMonth.withDayOfMonth(1);
        LocalDate lastDay = firstDay.with(TemporalAdjusters.lastDayOfMonth());


        // 转换为字符串并打印结果
        String firstDayStr = firstDay.format(DATE_FORMATTER);
        String lastDayStr = lastDay.format(DATE_FORMATTER);

        String sql = "select a.id,a.workcode,a.lastname,a.birthday,a.sex,a.subcompanyid1,a.departmentid,a.managerid,a.companystartdate,\n" +
                "a.createdate,a.accumfundaccount,b."+account+" as account,b."+bankField+" as bankname,c."+femdate+" as femdate,\n" +
                "a.startdate,a.enddate,a.jobtitle,a.status,a.educationlevel,a.mobile,a.certificatenum,\n" +
                "a.nativeplace,b."+regresidentplace+" as regresidentplace from hrmresource a\n" +
                "left join cus_fielddata b on a.id = b.id and b.scopeid = 1\n" +
                "left join cus_fielddata c on a.id = c.id and c.scopeid = -1\n" +
                "where a.companystartdate <= '"+lastDayStr+"'";

        if (!StringUtil.isEmpty(subcompanyId) && !StringUtil.isEmpty(departmentId)) {
            sql += " and (a.subcompanyid1 = "+subcompanyId+" or a.departmentid ="+departmentId+")";
        } else if (!StringUtil.isEmpty(subcompanyId)) {
            sql += " and a.subcompanyid1 ="+subcompanyId;
        }else if (!StringUtil.isEmpty(departmentId)) {
            sql += " and a.departmentid ="+departmentId;
        }


        if (!"9".equals(status)) {
            //在职
            if ("8".equals(status)) {
                sql += " and a.status < 4";
            }else {
                sql += " and a.status = "+status;
            }
        }



        rs.executeQuery(sql);

        List<HistoryResourcePO> historyResourceList = new ArrayList<>();
        while (rs.next()) {
            HistoryResourcePO build = HistoryResourcePO.builder()
                    .resourceId(Util.getIntValue(rs.getString("id")))
                    .workcode(Util.null2String(rs.getString("workcode")))
                    .lastName(Util.null2String(rs.getString("lastname")))
                    .birthday(Util.null2String(rs.getString("birthday")))
                    .sex("0".equals(Util.null2String(rs.getString("sex"))) ? "男" : "女")
                    .subCompany(ResourceSnipUtils.selectSubCompanyName(Util.null2String(rs.getString("subcompanyid1"))))
                    .department(ResourceSnipUtils.selectDeptName(Util.null2String(rs.getString("departmentid"))))
                    .managerId(ResourceSnipUtils.selectResourceName(Util.null2String(rs.getString("managerid"))))
                    .companyStartDate(Util.null2String(rs.getString("companystartdate")))
                    .createDate(Util.null2String(rs.getString("createdate")))
                    .accumfundAccount(Util.null2String(rs.getString("accumfundaccount")))
                    .accountId(Util.null2String(rs.getString("account")))
                    .bankName(ResourceSnipUtils.selectBankName(Util.null2String(rs.getString("bankname")),bankField))
                    .firstEnrollmentDate(Util.null2String(rs.getString("femdate")))
                    .startdate(Util.null2String(rs.getString("startdate")))
                    .endDate(Util.null2String(rs.getString("enddate")))
                    .jobTitle(ResourceSnipUtils.selectJobName(Util.null2String(rs.getString("jobtitle"))))
                    .status(ResourceSnipUtils.selectStatusName(Util.null2String(rs.getString("status"))))
                    .educationlevel(ResourceSnipUtils.selectEducName(Util.null2String(rs.getString("educationlevel"))))
                    .mobile(Util.null2String(rs.getString("mobile")))
                    .certificatenum(Util.null2String(rs.getString("certificatenum")))
                    .nativeplace(Util.null2String(rs.getString("nativeplace")))
                    .regresidentplace(Util.null2String(rs.getString("regresidentplace")))
                    .build();
            historyResourceList.add(build);
        }

        //todo 数据处理
        //3.花名册年月 选择 2024-09  查询数据 2024-9.30 之前所有入职人员 去掉离职日期是2024年9.01之前的数据（注意返聘情况）

        //3.1 选择日期前离职数据
        List<HrmStatusPO> leaveList = new ArrayList<>();
        rs.executeQuery("select resourceid,type_n,changedate from hrmstatushistory where type_n = 5 and changedate < '"+firstDayStr+"'");
        while (rs.next()){
            Integer resourceId = Util.getIntValue(rs.getString("resourceid"));
            Integer typeN = Util.getIntValue(rs.getString("type_n"));
            String changeDate = Util.null2String(rs.getString("changedate"));
            leaveList.add(HrmStatusPO.builder().resourceId(resourceId).typeN(typeN).changeDate(changeDate).build());
        }

        List<HrmStatusPO> leaveResult = filterList(leaveList);

        //3.2 返聘数据
        List<HrmStatusPO> returnList = new ArrayList<>();
        rs.executeQuery("select resourceid,type_n,changedate from hrmstatushistory where type_n = 7");
        while(rs.next()) {
            Integer resourceId = Util.getIntValue(rs.getString("resourceid"));
            Integer typeN = Util.getIntValue(rs.getString("type_n"));
            String changeDate = Util.null2String(rs.getString("changedate"));
            returnList.add(HrmStatusPO.builder().resourceId(resourceId).typeN(typeN).changeDate(changeDate).build());
        }

        List<HrmStatusPO> returnResult = filterList(returnList);

        //3.3 移除离职数据中存在返聘情况的人员 （返聘日期>离职日期）
        List<HrmStatusPO> compareList = compareList(leaveResult, returnResult);

        //3.4 查询数据中过滤人员
        List<HistoryResourcePO> filteredList = historyResourceList.stream()
                .filter(hrpo -> compareList.stream()
                        .noneMatch(hspo -> hspo.getResourceId().equals(hrpo.getResourceId())))
                .collect(Collectors.toList());


        //3.4 当月离职数据保留显示
        List<HrmStatusPO> leaveMonthList = new ArrayList<>();
        RecordSet rs1 = new RecordSet();
        rs1.executeQuery("select resourceid,type_n,changedate from hrmstatushistory where type_n = 5 \n" +
                "and changedate >= '"+firstDayStr+"' and changedate <= '"+lastDayStr+"'");

        while (rs1.next()) {
            Integer resourceId = Util.getIntValue(rs1.getString("resourceid"));
            Integer typeN = Util.getIntValue(rs1.getString("type_n"));
            String changeDate = Util.null2String(rs1.getString("changedate"));
            leaveMonthList.add(HrmStatusPO.builder().resourceId(resourceId).typeN(typeN).changeDate(changeDate).build());
        }

        List<HrmStatusPO> leaveMonthResult = filterList(leaveMonthList);

        Map<Integer, String> leaveMonthMap = leaveMonthResult.stream()
                .collect(Collectors.toMap(HrmStatusPO::getResourceId, HrmStatusPO::getChangeDate));

        filteredList.forEach(hrpo -> {
            String newDate = leaveMonthMap.get(hrpo.getResourceId());
            if (newDate != null) {
                hrpo.setChangeDate(newDate);
            }
        });



        resultMap.put("data",filteredList);
        return resultMap;
    }

    @Override
    public XSSFWorkbook hrResourceExport(HttpServletRequest request, HttpServletResponse response, Map<String, Object> param) {
        BaseBean bb = new BaseBean();
        String companyStartDate = Util.null2String(param.get("companyStartDate"));
        //全字段导出
        List<Object> headerList = Arrays.asList("编号","姓名","出生日期","性别","分部","部门","岗位","直接上级","入职日期","离职日期","状态","创建日期","公积金账户","工资账户","工资银行","首次参保时间",
                "合同开始日期","合同结束日期","学历","电话","身份证号","籍贯","户口所在地");

        Map<String, List<HistoryResourcePO>> stringMap = hrResource(param);
        List<HistoryResourcePO> historyResourcePOS = stringMap.get("data");

        List<List<Object>> rows = new LinkedList<>();
        for (HistoryResourcePO hr : historyResourcePOS) {
            List<Object> row = new LinkedList<>();
            row.add(hr.getWorkcode());
            row.add(hr.getLastName());
            row.add(hr.getBirthday());
            row.add(hr.getSex());
            row.add(hr.getSubCompany());
            row.add(hr.getDepartment());
            row.add(hr.getJobTitle());
            row.add(hr.getManagerId());
            row.add(hr.getCompanyStartDate());
            row.add(hr.getChangeDate());
            row.add(hr.getStatus());
            row.add(hr.getCreateDate());
            row.add(hr.getAccumfundAccount());
            row.add(hr.getAccountId());
            row.add(hr.getBankName());
            row.add(hr.getFirstEnrollmentDate());
            row.add(hr.getStartdate());
            row.add(hr.getEndDate());
            row.add(hr.getEducationlevel());
            row.add(hr.getMobile());
            row.add(hr.getCertificatenum());
            row.add(hr.getNativeplace());
            row.add(hr.getRegresidentplace());

            rows.add(row);
        }


        List<List<Object>> excelSheetData = new ArrayList<>();
        excelSheetData.add(headerList);
        excelSheetData.addAll(rows);
        String sheetName = "花名册快照"+companyStartDate;

        return ExcelUtil.genWorkbookV2(excelSheetData, sheetName);
    }

    private List<HrmStatusPO> filterList(List<HrmStatusPO> list) {
        return list.stream()
                .collect(Collectors.groupingBy(
                        HrmStatusPO::getResourceId,
                        Collectors.maxBy(Comparator.comparing(
                                po -> LocalDate.parse(po.getChangeDate(), DATE_FORMATTER)
                        ))
                ))
                .values()
                .stream()
                .filter(Optional::isPresent)
                .map(Optional::get)
                .collect(Collectors.toList());
    }

    private List<HrmStatusPO> compareList(List<HrmStatusPO> leaveResult,List<HrmStatusPO> returnResult) {

        Map<String, LocalDate> returnResultMap = returnResult.stream()
                .collect(Collectors.toMap(
                        po -> po.getResourceId().toString(),
                        po -> LocalDate.parse(po.getChangeDate(), DATE_FORMATTER)
                ));

        // 2. 更新 leaveResult，移除不符合条件的条目
        return leaveResult.stream()
                .filter(leavePo -> {
                    LocalDate leaveDate = LocalDate.parse(leavePo.getChangeDate(), DATE_FORMATTER);
                    LocalDate returnDate = returnResultMap.get(leavePo.getResourceId().toString());
                    return returnDate == null || leaveDate.isAfter(returnDate);
                })
                .collect(Collectors.toList());
    }

}
