package com.engine.kqsolution.util;

import weaver.conn.RecordSet;
import weaver.general.Util;
import weaver.hrm.company.DepartmentComInfo;
import weaver.hrm.company.SubCompanyComInfo;
import weaver.hrm.job.EducationLevelComInfo;
import weaver.hrm.job.JobTitlesComInfo;
import weaver.hrm.resource.ResourceComInfo;

/**
 * @Author liang.cheng
 * @Date 2024/8/28 2:35 PM
 * @Description: 人员数据类型转换工具
 * @Version 1.0
 */
public class ResourceSnipUtils {


    /**
     * 分部
     * @param subcompanyid
     * @return
     */
    public static String selectSubCompanyName(String subcompanyid) {
        SubCompanyComInfo sub = new SubCompanyComInfo();
        return sub.getSubCompanyname(subcompanyid);
    }

    /**
     * 部门
     * @param departmentId
     * @return
     */
    public static String selectDeptName(String departmentId) {
        DepartmentComInfo dept = new DepartmentComInfo();
        try {
            return dept.getDepartmentName(departmentId);
        } catch (Exception e) {
            return "";
        }
    }

    /**
     * 岗位
     * @param jobId
     * @return
     */
    public static String selectJobName(String jobId) {
        JobTitlesComInfo jc = new JobTitlesComInfo();
        return jc.getJobTitlesname(jobId);
    }

    /**
     * 人员
     * @param resourceId
     * @return
     */
    public static String selectResourceName(String resourceId) {
        try {
            ResourceComInfo rc = new ResourceComInfo();
            return rc.getLastname(resourceId);
        } catch (Exception e) {
            return "";
        }
    }

    /**
     * 性别
     * @param sex
     * @return
     */
    public static String selectSexName(String sex) {
       return "0".equals(sex) ? "男" : "女";
    }


    /**
     * 工资银行
     * @param fieldId
     * @param value
     * @return
     */
    public static String selectBankName(String value,String fieldId){
        RecordSet rs = new RecordSet();
        String id = fieldId.substring(Math.min(5, fieldId.length()));
        rs.executeQuery("select selectname from cus_selectitem where fieldid = ? and selectvalue = ?",id,value);
        rs.next();
        return Util.null2String(rs.getString("selectname"));
    }


    /**
     * 状态
     * @param status
     * @return
     */
    public static String selectStatusName(String status) {
        switch (status) {
            case  "0":
                return "试用";
            case  "1":
                return "正式";
            case  "2":
                return "临时";
            case  "3":
                return "试用延期";
            case  "4":
                return "解聘";
            case  "5":
                return "离职";
            case  "6":
                return "退休";
            case  "7":
                return "无效";
                default :
                    return "";
        }
    }

    /**
     * 学历
     * @param educLevel
     * @return
     */
    public static String selectEducName(String educLevel){
        EducationLevelComInfo educ = new EducationLevelComInfo();
        return  educ.getEducationLevelname(educLevel);
    }

}
