package com.engine.kqsolution.web;

import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.serializer.SerializerFeature;
import com.engine.common.util.ParamUtil;
import com.engine.common.util.ServiceUtil;
import com.engine.kqsolution.service.ProjectPriceService;
import com.engine.kqsolution.service.impl.ProjectPriceServiceImpl;
import weaver.hrm.HrmUserVarify;
import weaver.hrm.User;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.ws.rs.POST;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.MediaType;
import java.util.HashMap;
import java.util.Map;

/**
 * @Author liang.cheng
 * @Date 2024/9/2 10:18 AM
 * @Description:
 * @Version 1.0
 */
public class ProjectPriceAction {

    private ProjectPriceService getService(User user) {
        return  ServiceUtil.getService(ProjectPriceServiceImpl.class, user);
    }

    @POST
    @Path("/sign")
    @Produces(MediaType.TEXT_PLAIN)
    public String customSignData(@Context HttpServletRequest request, @Context HttpServletResponse response){
        Map<String, Object> data = new HashMap<>(8);
        try {
            User user = HrmUserVarify.getUser(request, response);
            Map<String, Object> map = ParamUtil.request2Map(request);
            data.putAll(getService(user).signData(map));
            data.put("status", true);
        } catch (Exception e) {
            data.put("status", false);
            data.put("msg", "catch exception : " + e.getMessage());
        }
        return JSONObject.toJSONString(data, SerializerFeature.DisableCircularReferenceDetect);
    }
}
