package com.engine.kqsolution.web;

import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.serializer.SerializerFeature;
import com.engine.common.util.ServiceUtil;
import com.engine.kqsolution.entity.CustomSignDataParam;
import com.engine.kqsolution.entity.SignDataParams;
import com.engine.kqsolution.service.SignDataSummaryService;
import com.engine.kqsolution.service.impl.SignDataSummaryServiceImpl;
import io.swagger.v3.oas.annotations.parameters.RequestBody;
import weaver.hrm.HrmUserVarify;
import weaver.hrm.User;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.ws.rs.*;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.MediaType;
import java.util.HashMap;
import java.util.Map;

/**
 * @Author liang.cheng
 * @Date 2023/9/18 11:43 AM
 * @Description:
 * @Version 1.0
 */
public class SignDataSummaryAction {

    private SignDataSummaryService getService(User user) {
        return  ServiceUtil.getService(SignDataSummaryServiceImpl.class, user);
    }

    @POST
    @Path("/recordSignData")
    @Produces(MediaType.TEXT_PLAIN)
    public String recordSignData(@Context HttpServletRequest request, @Context HttpServletResponse response,@RequestBody SignDataParams signDataParams){
        Map<String, Object> data = new HashMap<>(8);
        try {
            User user = HrmUserVarify.getUser(request, response);
            data.putAll(getService(user).recordSignData(signDataParams));
            data.put("status", true);
        } catch (Exception e) {
            data.put("status", false);
            data.put("msg", "catch exception : " + e.getMessage());
        }
        return JSONObject.toJSONString(data, SerializerFeature.DisableCircularReferenceDetect);
    }

    @POST
    @Path("/customSignData")
    @Produces(MediaType.TEXT_PLAIN)
    public String customSignData(@Context HttpServletRequest request, @Context HttpServletResponse response,@RequestBody CustomSignDataParam customSignDataParam){
        Map<String, Object> data = new HashMap<>(8);
        try {
            User user = HrmUserVarify.getUser(request, response);
            data.putAll(getService(user).customSignData(customSignDataParam));
            data.put("status", true);
        } catch (Exception e) {
            data.put("status", false);
            data.put("msg", "catch exception : " + e.getMessage());
        }
        return JSONObject.toJSONString(data, SerializerFeature.DisableCircularReferenceDetect);
    }

    @GET
    @Path("/workflowDetail")
    @Produces(MediaType.TEXT_PLAIN)
    public String workflowDetail(@Context HttpServletRequest request, @Context HttpServletResponse response, @QueryParam("ids") String ids){
        Map<String, Object> data = new HashMap<>(8);
        try {
            User user = HrmUserVarify.getUser(request, response);
            data.put("datas",getService(user).workflowDetail(ids));
            data.put("status", true);
        } catch (Exception e) {
            data.put("status", false);
            data.put("msg", "catch exception : " + e.getMessage());
        }
        return JSONObject.toJSONString(data, SerializerFeature.DisableCircularReferenceDetect);
    }

}
