package test;

import weaver.common.DateUtil;

import java.time.LocalDate;
import java.time.format.DateTimeFormatter;
import java.time.temporal.TemporalAdjusters;

/**
 * @Author weaver_cl
 * @Description:
 * @Date 2022/10/9
 * @Version V1.0
 **/
public class MainTest {

    public static void main(String[] args) {

        String monthYear = "2023-02";

        // 定义日期格式，适用于解析"yyyy-MM"格式的字符串
        DateTimeFormatter monthYearFormatter = DateTimeFormatter.ofPattern("yyyy-MM");

        // 解析字符串为 LocalDate 对象（这里我们假设其表示该月的第一天）
        LocalDate firstDayOfMonth = LocalDate.parse(monthYear + "-01", DateTimeFormatter.ofPattern("yyyy-MM-dd"));

        // 获取本月的第一天
        LocalDate firstDay = firstDayOfMonth.withDayOfMonth(1);

        // 获取本月的最后一天
        LocalDate lastDay = firstDay.with(TemporalAdjusters.lastDayOfMonth());

        // 定义输出格式
        DateTimeFormatter outputFormatter = DateTimeFormatter.ofPattern("yyyy-MM-dd");

        // 转换为字符串并打印结果
        String firstDayStr = firstDay.format(outputFormatter);
        String lastDayStr = lastDay.format(outputFormatter);

        System.out.println("本月第一天: " + firstDayStr);
        System.out.println("本月最后一天: " + lastDayStr);
    }

    public static double calculateActualWorkHours(double punchInHours) {
        double adjustedHours;
        if (punchInHours <= 4.0) {
            adjustedHours = punchInHours;
        } else {
            adjustedHours = Math.floor(punchInHours - 1.0);
        }

        return adjustedHours;
    }
}
