package weaver.interfaces.kqsolution.crob;

import com.engine.kqsolution.service.impl.ProjectPriceServiceImpl;
import weaver.conn.RecordSet;
import weaver.interfaces.schedule.BaseCronJob;

import java.time.LocalDate;
import java.time.format.DateTimeFormatter;
import java.util.HashMap;
import java.util.Map;

/**
 * @Author liang.cheng
 * @Date 2024/9/2 10:08 AM
 * @Description: 产线工价台账
 * @Version 1.0
 */
public class ProjectPriceCrob extends BaseCronJob {


    @Override
    public void execute() {

        RecordSet rs = new RecordSet();
        ProjectPriceServiceImpl project = new ProjectPriceServiceImpl();
        LocalDate today = LocalDate.now();
        LocalDate firstDayOfMonth = today.withDayOfMonth(1);
        LocalDate lastDayOfMonth = today.withDayOfMonth(today.lengthOfMonth());

        DateTimeFormatter formatter = DateTimeFormatter.ofPattern("yyyy-MM-dd");

        String firstDay = firstDayOfMonth.format(formatter);
        String lastDay = lastDayOfMonth.format(formatter);

        Map<String,Object> params = new HashMap<>();
        params.put("fromdate",firstDay);
        params.put("todate",lastDay);

        //todo 执行前先删除历史数据 主表 明细表

        // 获取当前月份的格式化字符串
        DateTimeFormatter formatter1 = DateTimeFormatter.ofPattern("yyyy-MM");
        String currentMonth = today.format(formatter1);
        project.deleteHData(currentMonth,"");

        project.signData(params);


    }
}
